unit timeserver;

interface
uses Classes, Windows;

type TTimeServer = class(TThread)
        constructor create(SendSock: String; ListenSock: String; ownid: array of byte); virtual;
        procedure Execute; override;
private
        SendSocket: String;
        ListenSocket: String;
        id: array[0..7] of byte;
end;

implementation

uses SysUtils, libparticle, DateUtils;

constructor TTimeServer.create(SendSock: String; ListenSock: String; ownid: array of byte);
var i : integer;
begin
        SendSocket := Sendsock;
        ListenSocket := ListenSock;
        for i:= 0 to 7 do id[i] := ownid[i];
        inherited create(false);
end;

procedure TTimeServer.Execute;
var cldata: pcl_packet;
    testcl: pcl_packet;
    acldata: pacl_packet;
    recievecl: pcl_packet;

    ps, pr, i: integer;
    pctime: TDateTime;
    ptime: array[0..7] of Byte;
    sport, rport: integer;
    stop: Cardinal;

begin
	sport := StrToInt(ListenSocket);
	rport := StrToInt(SendSocket);

	ps := p_socket(sport, @id);
	pr := p_socket(rport, @id);
        p_set_blockingmode(pr, 0);

        {Ensure that no other timeserver is running}
        testcl := create_cl_packet(2);
        acldata := create_acl_packet('CTR', nil, 0);
        add_acl_packet(testcl, acldata);
        p_send(ps, testcl);
        cldata := nil;

        stop:= GetTickCount + 1000;
        while (GetTickCount < stop) and not Terminated do begin
                p_send(ps, testcl);
                cldata := p_recv(pr, ps);
                if (cldata <> nil) then begin
                        if get_next_acl_packet_by_type(cldata, 'CTA') <> nil then
                        self.Terminate;
                        free_cl_packet(cldata);
                        cldata:= nil;
                end;
                Sleep(10);
        end;

        free_cl_packet(testcl);

        if not Terminated then p_add_filter(pr, 'CTR');
	while not Terminated do begin

		recievecl := p_recv(pr, ps);

		if (recievecl <> nil) then begin

			cldata := create_cl_packet(2);
                        pctime := Date + Time;
			ptime[0] := YearOf(pctime) - 2000;
			ptime[1] := MonthOf(pctime);
			ptime[2] := DayOf(pctime);
			ptime[3] := HourOf(pctime);
			ptime[4] := MinuteOf(pctime);
			ptime[5] := SecondOf(pctime);
			ptime[6] := 0;
			ptime[7] := 0;

			acldata := create_acl_packet('CTA', @ptime, 8);
			add_acl_packet(cldata, acldata);

			for i:= 0 to 9 do p_send(ps, cldata);

			free_cl_packet(cldata);
			free_cl_packet(recievecl);
                        recievecl := nil;
		end;
                Sleep(10);
        end;
	p_close(ps);
	p_close(pr);

end;

end.
