/*
*
*	ACL Stack
*	ACL.c
*	TecO, University of Karlsruhe
*	Author:		Michael Beigl
*	Date:		7.3.2002
*	Version:        0.1
*	known bugs:
*	todo:
*
*/


	#include <winsock2.h>
#include <windows.h>
    #include <stdio.h> 
    #include <stdlib.h> 
    #include <errno.h> 
    #include <string.h> 
    #include <sys/types.h>
	#include <process.h>
#include <winbase.h>
#include "acltypes.h"
#include "acl.h"



void ACL_send(UInt8 aclsize)
{
  ACLpkt_ready = TRUE;
  CL_send(aclsize);
}

void ACLsend()
{
  ACLpkt_ready = TRUE;
  CL_send(ACLptr_out);
}


UInt8 ACL_version_rec()
{
	return(rf_buffer_in[BUF_VERSION_POS]);
}


unsigned char* ACL_begin_rec()
{
	return ACLpkt_in;
}

UInt8 ACL_len_rec()
{
	return (rec_pkt_size - CL_SIZE);
}


UInt8 ACL_seqno_rec()
{
	return(rf_buffer_in[BUF_SEQ_POS]);
}


void ACL_ip_rec(UInt8 *ip)
{
  UInt8 myi;

  for (myi=BUF_IP_POS;myi<BUF_IP_POS+8;myi++)
  {
     *ip = rf_buffer_in[myi]; ip++;
  }
}

// Detect the type in the in-packet
// returns position of following len of data-byte if found, 0 if not

UInt8 ACL_detect_type(UInt8 first, UInt8 sec)
{
   UInt8 ii,xx;
   xx = 0; // FALSE
   ii = 0;
   while (ii<ACL_len_rec())
   {
	if (ACL_len_rec()>=ii+1)
	{ if ((ACLpkt_in[ii]==first)&&(ACLpkt_in[ii+1]==sec)) {xx = ii+2; break; }
        ii= ii+2;
        if (ACL_len_rec()>=ii) ii = ii+ ACLpkt_in[ii]; // skip data
      }
      else break;
   }
   return xx;
}



 boolean ACL_pfind_type(UInt8 position, UInt8 type_high, UInt8 type_low)
{
	if ((ACLpkt_in[position]== type_high)&&(ACLpkt_in[position+1]== type_low)) return(TRUE);
	else return(FALSE);
}


boolean ACL_find_type(UInt8 type_high, UInt8 type_low, UInt8 *len, UInt8** data)
{ UInt8 i;
	i = 0;
	while (i<ACL_len_rec())
	{
		if (ACL_pfind_type(i, type_high, type_low)) break;
		i+=2;
		i+=ACLpkt_in[i]+1;
	}
	if (i<ACL_len_rec()) {
		i+=2;
		*len = ACLpkt_in[i];
		*data = &(ACLpkt_in[i+1]);
		return(TRUE);
	}
	else return(FALSE);
}




void tuple_add(UInt8 type_high, UInt8 type_low, UInt8 len, UInt8* data)
{
	if (!ACLpkt_ready)
	{
		ACLpkt_out[ACLptr_out++] = type_high;
		ACLpkt_out[ACLptr_out++] = type_low;
		ACLpkt_out[ACLptr_out++] = len;
		memcpy(&(ACLpkt_out[ACLptr_out]), data, len);
		ACLptr_out+=len;
	}
}



/**
 * Decodes the type field of a data tuple.
 * Returns a pointer to the decodes type.
 * @param type the encoded type
 * @param a pointer to where the decoded type should be stored ( (3 bytes = type) + \0 = 4 bytes)
 * @return pointer to decType
 */
unsigned char* ACL_decode(unsigned char* type, unsigned char* decType)
{
	unsigned int len = 2;
	unsigned short i,ii,y;

	ii = 0;
	for (i=0; i<len;)
	{
        y = ((type[i] << 8) & 0xFF00) | (type[i+1] & 0x00FF);
		decType[ii] = (y % 40);
		y = y - (decType[ii]);
		decType[ii+1] = ((y % 1600)/40);
		y = y - ((decType[ii+1])*40);
		decType[ii+2] = (y / 1600);
		ii += 3; i +=2;
	}

	decType[ii] = '\0'; i = ii;

	for (ii=0;ii<i;ii++)
	{
		decType[ii]+=0x30;
		if (decType[ii]==0x3C) decType[ii] = 0x20;
        if (decType[ii]==0x3b) decType[ii] = 0x2f;
		if (decType[ii]==0x3A) decType[ii] = 0x2D;

		if ((decType[ii]>='@'-3)&&(decType[ii]<='Z'-3)) decType[ii] +=3;
		if ((decType[ii]>='A')&&(decType[ii]<='Z')) decType[ii] +=0x20;
	}

    return decType;
}


//////////////////////////////////////////////////////////////////////////////////////
// detect and add types
void HELO_add(UInt8* ip)
{
	ACLpkt_ready = FALSE;
	ACLptr_out = 0;
	tuple_add(HELO_COMMAND_HI, HELO_COMMAND_LO, 8, ip);
}

boolean HELO_det(UInt8 **ip)
{	
	*ip = ACLpkt_in+3;
	return ACL_pfind_type(0, HELO_COMMAND_HI, HELO_COMMAND_LO);
}

//////
void OLEH_add(UInt8* ip)
{
	ACLpkt_ready = FALSE;
	ACLptr_out = 0;
	tuple_add(OLEH_COMMAND_HI, OLEH_COMMAND_LO, 8, ip);
}

boolean OLEH_det(UInt8** ip)
{
   
   *ip = ACLpkt_in+3;
   return ACL_pfind_type(0, OLEH_COMMAND_HI, OLEH_COMMAND_LO);
}

//////////////////////////////////////////////////////////////////////
// Artefact types
void CHAIR_add(UInt8 version)
{
	ACLpkt_ready = FALSE;
	ACLptr_out = 0;
	tuple_add(CHAIR_COMMAND_HI, CHAIR_COMMAND_LO, 1, &version);
}

boolean CHAIR_det(UInt8** version)
{
   
   *version = ACLpkt_in+3;
   return ACL_pfind_type(0, CHAIR_COMMAND_HI, CHAIR_COMMAND_LO);
}

/////
void SMARTIT_add(UInt8 version)
{
	ACLpkt_ready = FALSE;
	ACLptr_out = 0;
	tuple_add(SMARTIT_COMMAND_HI, SMARTIT_COMMAND_LO, 1, &version);
}

boolean SMARTIT_det(UInt8* version)
{
   
   *version = ACLpkt_in[3];
   return ACL_pfind_type(0, SMARTIT_COMMAND_HI, SMARTIT_COMMAND_LO);
}

/////

void ACM_add()
{

	ACLpkt_ready = FALSE;
	ACLptr_out = 0;
	ACLpkt_out[ACLptr_out++] = ACL_TYPE_ACM_H;
	ACLpkt_out[ACLptr_out++] = ACL_TYPE_ACM_L;
	ACLpkt_out[ACLptr_out++] = 0;

  }

void PRG_add(UInt8 len, UInt8* data)
{
//	ACLpkt_ready = FALSE;
//	ACLptr_out = 0;
	tuple_add(PROG_COMMAND_HI, PROG_COMMAND_LO, len, data);
}

void SetID_add(UInt8* ip)
{
//	ACLpkt_ready = FALSE;
//	ACLptr_out = 0;
	tuple_add(109, 192, 8, ip);
}

boolean PRG_det(unsigned int* seqno)
{
   unsigned int i;

   i=256*ACLpkt_in[6];
   i+=ACLpkt_in[7];
   *seqno = i;
   //memcpy(seqno, &(ACLpkt_in[3]), 2);
   return ACL_pfind_type(3, PROG_COMMAND_HI, PROG_COMMAND_LO);
}

boolean setIDack_det(UInt8* ip)
{
	UInt8 senderIP[8];
	unsigned int i;
	if(ACL_pfind_type(3, 109,192))
	{
		ACL_ip_rec(senderIP);
		for(i=0;i<8;i++)
		{
			if(senderIP[i]!=ip[i]) return FALSE;
		}
		return TRUE;

	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////////
// 2nd types
void SWITCH_add(UInt8 turns)
{
	tuple_add(SWITCH_COMMAND_HI, SWITCH_COMMAND_LO, 1, &turns);
}

boolean SWITCH_det(UInt8* turns)
{ UInt8 len;
  UInt8 *pdata;
   
   if (ACL_find_type(SWITCH_COMMAND_HI, SWITCH_COMMAND_LO, &len, &pdata)== FALSE) return (FALSE);
   if (len!=1) return (FALSE);
   *turns = pdata[0];

   return (TRUE);
}

boolean ACCL_det(UInt8* x, UInt8* y)
{ UInt8 len;
  UInt8 *pdata;
   
   if (ACL_find_type(ACCL_COMMAND_HI, ACCL_COMMAND_LO, &len, &pdata)==FALSE) return (FALSE);
   if (len!=2) return (FALSE);
   *x = pdata[0]; *y = pdata[1];
   return (TRUE);
}

void ACCL_add(UInt8 x, UInt8 y)
{ UInt8 data[2];

	data[0] = x; data[1] = y,
	tuple_add(ACCL_COMMAND_HI, ACCL_COMMAND_LO, 2, data);
}


boolean ACL_type_det(UInt8 position)
{
	// to be done ....
	return 0;
}

/////////////////////////////////////////////////////
boolean ACL_icmp_check()
{  
	unsigned int s;

	if (PRG_det(&s)) { detected_seqno = s; 
	}
	return (FALSE);
}
