#include "common.h"
#include "dlc.h"

// Update the CRC for transmitted and received data using
// the CCITT 16bit algorithm (X^16 + X^12 + X^5 + 1).
void CRC16(unsigned int ser_data, unsigned short *crc2)
{
	unsigned short crc;
	crc = *crc2;
    //static unsigned int crc;

    crc  = (unsigned int)(crc >> 8) | (crc << 8);
    crc ^= ser_data;
    crc ^= (unsigned int)(crc & 0xff) >> 4;
    crc ^= (crc << 8) << 4;
    crc ^= ((crc & 0xff) << 4) << 1;
	*crc2 = crc;
}


// Example
// 	crc = 0;
//	for (i=0; i<size; i++) CRC16(pkt[i],&crc);


boolean CL_crc_test()
{
  unsigned short crc;
  UInt8 i;

  crc = 0;
//  for (i=0; i<rf_buffer_in[BUF_SIZE_POS]+2; i++) 
  for (i=0; i<rec_pkt_size; i++) 
	CRC16(rf_buffer_in[i],&crc);
  if (crc==0) return(TRUE);
  else return(FALSE);
}
