#include <winsock2.h>
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <process.h>
#include <winbase.h>

#include <time.h>

#include "common.h"
#include "acltypes.h"
#include "dlc.h"
#include "acl.h"
#include "otaplib.h"

#define BACKLOG 10     /* how many pending connections queue will hold */


typedef struct
{
		char s[255];
}
PARAMS, *PPARAMS;


typedef void *PVOID;

//void Thread1 (PVOID pvoid);
void serverX(PVOID pvoid);

void CL_send(UInt8 aclsize);

char szBuff[ 80 ];         /* Temp buffer - used to pass strings    */
                           /* to and from dialog boxes, etc         */

struct tm *newtime;
time_t aclock,bclock,exclock;

UInt8 achtex;
boolean firstlinenodata;

void init_winsock()
{
		WORD wVersionRequested;
		WSADATA wsaData;
	int err;
	// zunchst mu Winsock initialisiert werden !!!!
		wVersionRequested = MAKEWORD( 2, 2 );
		err = WSAStartup( wVersionRequested, &wsaData );
		if ( err != 0 ) {
			errorvalue = WINSOCK_MISSING;
			return;
		}
		/* Confirm that the WinSock DLL supports 2.2.*/
		/* Note that if the DLL supports versions greater    */
		/* than 2.2 in addition to 2.2, it will still return */
		/* 2.2 in wVersion since that is the version we      */
		/* requested.                                        */
		if ( LOBYTE( wsaData.wVersion ) != 2 ||
	        HIBYTE( wsaData.wVersion ) != 2 ) {
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			WSACleanup( );
			errorvalue = WRONG_WINSOCK;
			return;
		}
}



void init_udp_client()
{
	int maxs;

 	    unsigned int opt1 = 1; // enable the option

		if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) ==  INVALID_SOCKET) {
            errorvalue = BROADCASTERROR;
            return;
        }

		// want to broadcast ??????????????? then set option !!!!!!!!!!!!!!!!!
	        maxs=1; // 1 = enable the option SO_BR'OADCAST
	    if (setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST,&opt1, sizeof(opt1))<0) {
			errorvalue = BROADCASTERROR;
			return;
		}


        server_addr.sin_family = AF_INET;         /* host byte order */
        WSAHtons(sockfd, CLIENTPORT, &(server_addr.sin_port));     /* short, network byte order */
		server_addr.sin_addr.s_addr = htonl (INADDR_BROADCAST);

        //phe = gethostbyname("129.13.169.109");
		//phe = gethostbyname("129.13.170.10");
        //phe = gethostbyname(INADDR_BROADCAST);
        //if (phe == NULL)
		//{
		//  exit(1);
		//}

        //memcpy( (char FAR *) &(server_addr.sin_addr), phe->h_addr, phe->h_length);

        my_addr.sin_family = AF_INET;         /* host byte order */
        my_addr.sin_port = htons(0);     /* short, network byte order */
        my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
		/* auto-fill with my IP */

//		Ntlich, wenn eine Kiste mehr als eine IP hat: direkt angeben, z.B.:
//		my_addr.sin_addr.s_addr = inet_addr("129.13.170.67");
//		memset(&(my_addr.sin_zero),0,8);  // macht den Rest auf 0, mu aber nicht sein

        if (bind ( sockfd, (SOCKADDR FAR *)&my_addr, sizeof ( my_addr ) ) \
                                                                      == SOCKET_ERROR) {
            errorvalue = WSA_ERROR;
//			exit(1);
        }
}

UInt8 ctod(char* s)
{
	UInt8 b;

	b=(*s) - '0';
	if ((*s) >'9') b=b-7;
	b = b*16;
	s++;
	b+=(*s) - '0';
	if ((*s) >'9') b=b-7;
	return b;
}

unsigned int find_end()
{
	unsigned int i;
	char s2[256], *s;
	unsigned long b;
	FILE *f;

	f = fopen(hexfile,"r");
	i = 0;

	s=s2;
	firstlinenodata=FALSE;
	{


		while (i<65000)
		{
			s = s2;
			if (fscanf(f,"%s",s)==EOF) break;
			i++;
			s+=8;
			b= ctod(s);
			if ((*s) == '4') //4 marks no regular data
			{
				s+=3;
				if((*s) == '3')		//means next data is for address 0x30000, which is no program data anymore
				{fclose(f); return(i-2);}
				else i--;			//then this means data is for address 0x0????, which is still programm data 
			}
		}
	}
	fclose(f);
	return(0);
}


void CRC16calc(UInt8 ser_data, UInt8 *crc_hb, UInt8 *crc_lb)
{
	UInt8 hb, lb;
	UInt8 tmp, tmp2;
	hb = *crc_hb;
	lb = *crc_lb;

    tmp = lb;
    lb = hb;
    hb = tmp;

    lb ^= ser_data;

    lb ^= lb >> 4;

    hb ^= lb << 4;


	hb ^= lb >> 3;
	lb ^= (lb << 4) << 1;

	*crc_hb = hb;
	*crc_lb = lb;

}

	


boolean parse_line(char* s, UInt8 *addrhi, UInt8 *addrlo, UInt8 *datalen, UInt8 *data)
{
	unsigned int i;

	if (*s != ':') return FALSE;
	s++;
	*datalen = ctod(s);
	s+=2;
	*addrhi = ctod(s);
	s+=2;
	*addrlo = ctod(s);
	s+=4;	// skip type of record
	for (i=0;i<*datalen;i++)
	{
		data[i]=ctod(s);
		s+=2;
	}
	return TRUE;
}


boolean wait_for_ack(unsigned int sno)
{
	int i;
	i = 0;

	while (i<65)
	{
		if (detected_seqno==sno) return TRUE;
		if ((sno==2) && (detected_seqno==1)) return FALSE;
		if  ((sno>2) && (detected_seqno==(sno-2))) return FALSE;
		if (detected_seqno==0xFFFF)
		{
			if(ACLpkt_in[11]==0) errorvalue = PRG_TOO_BIG;
			if(ACLpkt_in[8]!=OTAPVERSION) errorvalue = WRONG_VERSION;
			if(ACLpkt_in[9]!=OTAP_PROCESSOR_HI && ACLpkt_in[10]!=OTAP_PROCESSOR_LO) errorvalue = WRONG_HEX_FILE;
			return FALSE;
		}
		if (detected_seqno==0xCCCC)
		{
			errorvalue = CRC_ERROR;
			return FALSE;
		}
		i++;
		Sleep(1);
	}
	return FALSE;
}

boolean init_tablesData(unsigned int *anzlines, UInt8 *tablesdata)
{

	UInt8 addrhi,addrlo,anztables,td_count,linehi,linelo,bytecount,ii,bytedata,pcrc_h,pcrc_l,tcrch,tcrcl,linetype,addr3;
	unsigned int i,anzlines_tmp;
	char s2[256], *s;
	unsigned long addr,last_addr,line;
	FILE *f;

	for(i=0;i<37;i++)
	{
		tablesdata[i]=0;
	}

	f = fopen(hexfile,"r");
	anzlines_tmp=*anzlines;
	anztables=0;
	last_addr=0;
	td_count=5;
	bytecount=0;
	achtex=0;
	pcrc_h=0;pcrc_l=0;
	s=s2;
	{
		i = 0;
		line=1;
		addr3=0;
		while (i<anzlines_tmp)
		{
			s = s2;
			if (fscanf(f,"%s",s)==EOF) break;
			s++;						//skip ':'
			bytecount=ctod(s);			//datalen
			s+=2;
			addrhi = ctod(s);
			s+=2;
			addrlo = ctod(s);
			s+=2;
			linetype = ctod(s);
			s+=2;

			addr = 0;
			addr = addrhi * 256;
			addr = addr + addrlo;

			if(linetype == 4) addr3++;

			if(linetype == 0)			//regular data
			{
				i++;

				//for 18F452 and 18F6620
				if(OTA_RW_START<0x10000)
				{
				if(addr==8)
				{
					anzlines_tmp++;
					achtex=1;
					line++;
				}
				else if(addr==16 &&achtex);			//1st two lines will be merged, if separated, don't count twice
				else if(addr>=OTA_RW_START)
				{
					(*anzlines)--;						//don't send
				}
				else if(addr!=(last_addr+16))		//addr=8 und addr=16 sind Sonderflle
				{

					tablesdata[td_count  ]=addrhi;
					tablesdata[td_count+1]=addrlo;
					if(line>=1 &&td_count>4)
					{
						linehi = (UInt8) (line / 256);
						linelo = (UInt8) (line % 256);
						tablesdata[td_count-2]=linehi;
						tablesdata[td_count-1]=linelo;
					}
					td_count+=4;

					line=1;
					anztables++;
				}
				else line++;
				last_addr=addr;
				}
				//end: for 18F452 and 18F6620


				//for 18F6720
				else
				{

				if(addr3<2 && addr==8)
				{
					anzlines_tmp++;
					achtex=1;
					line++;
				}
				else if(addr3<2 && addr==16 &&achtex);			//1st two lines will be merged, if separated, don't count twice
				else if((addr3==2) && (addr>=(OTA_RW_START-0x10000)))
				{
					(*anzlines)--;						//don't send
				}
				else if(addr3==2 && addr==0) line++;
				else if(addr3<2 && addr!=(last_addr+16))		//addr=8 und addr=16 sind Sonderflle
				{

					tablesdata[td_count  ]=addrhi;
					tablesdata[td_count+1]=addrlo;
					if(line>=1 &&td_count>4)
					{
						linehi = (UInt8) (line / 256);
						linelo = (UInt8) (line % 256);
						tablesdata[td_count-2]=linehi;
						tablesdata[td_count-1]=linelo;
					}
					td_count+=4;

					line=1;
					anztables++;
				}
				else line++;
				last_addr=addr;
				}
				//end: for 18F6720
				
				//calc CRC
				if(addr<=8)
				{
					for(ii=0;ii<bytecount;ii++)
					{
						bytedata=ctod(s);
						s+=2;
						CRC16calc(bytedata,&pcrc_h,&pcrc_l);
					}
					for(;ii<8;ii++)
					{
						bytedata=0xFF;
						CRC16calc(bytedata,&pcrc_h,&pcrc_l);
					}
				}

				else if(OTA_RW_START>0xFFFF)
				{
					if((addr3<2) || ((addr3==2) && (addr<(OTA_RW_START-0x10000))))
					{
						for(ii=0;ii<bytecount;ii++)
						{
							bytedata=ctod(s);
							s+=2;
							CRC16calc(bytedata,&pcrc_h,&pcrc_l);
						}
						for(;ii<16;ii++)
						{
							bytedata=0xFF;
						CRC16calc(bytedata,&pcrc_h,&pcrc_l);
						}
					}
				}
				else if(addr<OTA_RW_START)
				{
					for(ii=0;ii<bytecount;ii++)
					{
						bytedata=ctod(s);
						s+=2;
						CRC16calc(bytedata,&pcrc_h,&pcrc_l);
					}
					for(;ii<16;ii++)
					{
						bytedata=0xFF;
						CRC16calc(bytedata,&pcrc_h,&pcrc_l);
					}
				}
			}

		}
		linehi = (UInt8) (line / 256);
		linelo = (UInt8) (line % 256);
		tablesdata[td_count-2]=linehi;
		tablesdata[td_count-1]=linelo;
		tablesdata[4]=anztables;


	}
	if(anztables>8)
	{
		errorvalue = TOO_MANY_PROGRAM_SECTIONS;
		return FALSE;
	}

	tablesdata[0] = pcrc_h;
	tablesdata[1] = pcrc_l;

	tcrch=pcrc_h;tcrcl=pcrc_l;
	CRC16calc(pcrc_h,&tcrch,&tcrcl);
	CRC16calc(pcrc_l,&tcrch,&tcrcl);
//printf("\n%u,%u\n",tcrch,tcrcl);

	tablesdata[2] = (UInt8) ((*anzlines) / 256);
	tablesdata[3] = (UInt8) ((*anzlines) % 256);

/*DEBUG
	for(i=0;i<45;i++)
	{
		printf("%u ",tablesdata[i]);
	}
*/
	fclose(f);

	return TRUE;
}


void get_processor_type()
{
	int i;
	char s2[256], *s;
	FILE *f;

	f=fopen(hexfile,"r");;
	i=0;
	while(i<65000)
	{
		s = s2;
		if (fscanf(f,"%s",s)==EOF)
		{
			printf("Couldn't detect processor type or unknown processor type.\n");
			fclose(f);
			exit(1);
		}
		i++;
			if(strstr(s2, "PIC18F452")!=NULL)
			{
				OTAP_PROCESSOR_HI=4;
				OTAP_PROCESSOR_LO=52;
				OTA_RW_START=0x7980;
				fclose(f);
				break;
			}
			else if(strstr(s2, "PIC18F6620")!=NULL)
			{
				OTAP_PROCESSOR_HI=66;
				OTAP_PROCESSOR_LO=20;
				OTA_RW_START=0xB980;
				fclose(f);
				break;
			}
			else if(strstr(s2, "PIC18F6720")!=NULL)
			{
				OTAP_PROCESSOR_HI=67;
				OTAP_PROCESSOR_LO=20;
				OTA_RW_START=0x14000;
				fclose(f);
				break;
			}
	}
}

void otap(void *percentfinished(int percent) )
{
//	unsigned char c;
	UInt8 i,iii,iiii,temp_b;
	unsigned int ii, anzlines;

	//*****************for PCH hex file:
//	unsigned int anztables;
	boolean tables_ok, otaperror;

	//**********************************/

	UInt8 data[255], data2[255];
	unsigned int seqno;
	boolean myeof;
        /* listen on sock_fd, new connection on new_fd */
	FILE* f;
	char s[256],*s1;
	UInt8 addrhi, addrlo, datalen;
	int addr;
	UInt8 tablesdata[37];
	int lastfinished;

	myeof = FALSE;
	
	get_processor_type();

	anzlines = find_end();

	tables_ok=init_tablesData(&anzlines,tablesdata);

	otaperror=FALSE;
	
	if (anzlines>0 && tables_ok)
	{



		memcpy(data2,&tidhigh,4);
		memcpy(data2+4,&tidlow,4);		// target ID
		data2[8] = 0; data2[9] = 0;

		anzlines++;
		anzlines/=2;
		anzlines*=2;					//always equal



		data2[14] = (UInt8) (anzlines % 256);
		data2[13] = (UInt8) (anzlines / 256);



		data2[10]=OTAPVERSION;

		data2[11]=OTAP_PROCESSOR_HI;
		data2[12]=OTAP_PROCESSOR_LO;		
		
		memcpy(&(data2[15]), tablesdata, 37);

		ACM_add();
		PRG_add(52, data2);
		detected_seqno = 2;

		ACLsend();
		for (iii=0;iii<10;iii++)
		{
			if (!wait_for_ack(1)) ACLsend();			
			else break;
		}
		if (!wait_for_ack(1)) {
			errorvalue = NO_START_ACK;		
			otaperror=TRUE;
			return FALSE; }

		f = fopen(hexfile,"r");
		seqno=2;



		fscanf(f,"%s",s);	//skip 1st line

		for (ii=0;ii<((anzlines+1)/2);ii++)
		{
			memcpy(data2,&tidhigh,4);
			memcpy(data2+4,&tidlow,4);		// target ID
			data2[9] = (UInt8) (seqno % 256);
			data2[8] = (UInt8) (seqno / 256);

			for(i=10;i<46;i++) data2[i]=0xFF;	//empty


			s1=s;
			if (fscanf(f,"%s",s)!=EOF)	{}	else { myeof = TRUE;}
			s1+=7;
			temp_b=ctod(s1);		//if temp_b==0, then this line has to be sent
			if(temp_b==0) 
			{
				s1=s;
				parse_line(s, &addrhi, &addrlo, &datalen, data); /////////////
			
				memcpy(&(data2[10]), data, datalen);

				//merge 1st 2 lines if necessary
				if(ii==0 && achtex && myeof==FALSE)
				{
					if (fscanf(f,"%s",s)!=EOF)	{}else { myeof = TRUE; }
					parse_line(s, &addrhi, &addrlo, &datalen, data); /////////////
					addr = 0;
					addr = addrhi * 256;
					addr = addr + addrlo;
					addr = (addr / 2);
					addrhi = (UInt8) (addr / 256);
					addrlo = (UInt8) (addr % 256);
					memcpy(&(data2[18]), data, datalen);
				}
				if (myeof==FALSE)
				{
					fscanf(f,"%s",s);
					parse_line(s, &addrhi, &addrlo, &datalen, data); /////////////
				}
				memcpy(&(data2[10+16]), data, datalen);

				ACM_add();
				PRG_add(10+16+16, data2);
				detected_seqno = 0;			
				ACLsend();

				for (iii=0;iii<50;iii++)
				{
					iiii=0;
					if (!wait_for_ack(seqno) && (errorvalue == 0))
					{ 
						detected_seqno = 0;
						ACLsend();
					}
					else { break;}
				}	

				if (iii>49)
					if (!wait_for_ack(seqno)) {
						if (errorvalue == 0) errorvalue = PROGRAMMING_ERROR; 
						otaperror=TRUE; 
						break;
					}		

				seqno+=2;
				if (lastfinished != (100 * ii) / ((anzlines+1)/2)) percentfinished((100 * ii) / ((anzlines+1)/2));
				lastfinished = (100 * ii) / ((anzlines+1)/2);
			}
		}
	
		time( &bclock );

		exclock=bclock-aclock;
		newtime = localtime( &exclock );		

		fclose(f);
	}
}

boolean trySettingID()
{
	UInt8 IP[8];
	int i,k;

	memcpy(IP,&tidhigh,4);
	memcpy(IP+4,&tidlow,4);		// target ID
	ACM_add();
	SetID_add(IP);
	ACLsend();
	i=0;

	while(i<20)
	{
		
		for(k=0;k<65;k++)
		{
			if(setIDack_det(IP)) return TRUE;
			Sleep(1);
		}
		ACLsend();
		i++;
	}
	return FALSE;

}



int otaprogram(void *percentfinished(int percent) , u_short sport, u_short cport, char *highid, char *lowid, char *hfile) {
	PVOID pvoidv;

	errorvalue = 0;
	comp_command(sport, cport, highid, lowid, hfile);

	// pre-setting the Packet Stuff
	rf_buffer_out[BUF_IP_POS] = 1; // IP
	rf_buffer_out[BUF_IP_POS+1] = 1; // IP
	rf_buffer_out[BUF_IP_POS+2] = 1; // IP
	rf_buffer_out[BUF_IP_POS+3] = 1; // IP
	rf_buffer_out[BUF_IP_POS+4] = 129; // IP
	rf_buffer_out[BUF_IP_POS+5] = 12; // IP
	rf_buffer_out[BUF_IP_POS+6] = 170; // IP
	rf_buffer_out[BUF_IP_POS+7] = 67; // IP
	sequenceNo = 1;

	time( &aclock );

	init_winsock();
	pvoidv = NULL;
	_beginthread(serverX, 0, pvoidv);

	init_udp_client();

////////////////////////////////////////////////////////////////////////////////////////


	// ACLpkt_in = &(rf_buffer_in[CL_SIZE-CRC_LEN]);
	ACLpkt_out = &(rf_buffer_out[CL_SIZE-CRC_LEN]);
	ACLpkt_in = &(rf_buffer_in[CL_SIZE-CRC_LEN]);

	rf_buffer_out[BUF_VERSION_POS] = RFVersion;
//	rf_buffer_out[BUF_FIELDSTRENGTH_POS] = fieldstrength;
	rf_buffer_out[BUF_SEQ_POS]	= sequenceNo;
		// send ( sockfd,  s,  14,0 );

	if (errorvalue == 0) otap(percentfinished);
	
	closesocket (sockfd); 
	return errorvalue;
}